# coding: utf-8

"""
    NCBI Datasets API

    NCBI service to query and download biological sequence data across all domains of life from NCBI databases.  # noqa: E501

    The version of the OpenAPI document: v1alpha
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ncbi.datasets.openapi.configuration import Configuration


class Datasetsv1Annotation(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'assemblies_in_scope': 'list[V1AnnotatedAssemblies]',
        'release_date': 'str',
        'release_name': 'str'
    }

    attribute_map = {
        'assemblies_in_scope': 'assemblies_in_scope',
        'release_date': 'release_date',
        'release_name': 'release_name'
    }

    def __init__(self, assemblies_in_scope=None, release_date=None, release_name=None, local_vars_configuration=None):  # noqa: E501
        """Datasetsv1Annotation - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._assemblies_in_scope = None
        self._release_date = None
        self._release_name = None
        self.discriminator = None

        if assemblies_in_scope is not None:
            self.assemblies_in_scope = assemblies_in_scope
        if release_date is not None:
            self.release_date = release_date
        if release_name is not None:
            self.release_name = release_name

    @property
    def assemblies_in_scope(self):
        """Gets the assemblies_in_scope of this Datasetsv1Annotation.  # noqa: E501


        :return: The assemblies_in_scope of this Datasetsv1Annotation.  # noqa: E501
        :rtype: list[V1AnnotatedAssemblies]
        """
        return self._assemblies_in_scope

    @assemblies_in_scope.setter
    def assemblies_in_scope(self, assemblies_in_scope):
        """Sets the assemblies_in_scope of this Datasetsv1Annotation.


        :param assemblies_in_scope: The assemblies_in_scope of this Datasetsv1Annotation.  # noqa: E501
        :type: list[V1AnnotatedAssemblies]
        """

        self._assemblies_in_scope = assemblies_in_scope

    @property
    def release_date(self):
        """Gets the release_date of this Datasetsv1Annotation.  # noqa: E501


        :return: The release_date of this Datasetsv1Annotation.  # noqa: E501
        :rtype: str
        """
        return self._release_date

    @release_date.setter
    def release_date(self, release_date):
        """Sets the release_date of this Datasetsv1Annotation.


        :param release_date: The release_date of this Datasetsv1Annotation.  # noqa: E501
        :type: str
        """

        self._release_date = release_date

    @property
    def release_name(self):
        """Gets the release_name of this Datasetsv1Annotation.  # noqa: E501


        :return: The release_name of this Datasetsv1Annotation.  # noqa: E501
        :rtype: str
        """
        return self._release_name

    @release_name.setter
    def release_name(self, release_name):
        """Sets the release_name of this Datasetsv1Annotation.


        :param release_name: The release_name of this Datasetsv1Annotation.  # noqa: E501
        :type: str
        """

        self._release_name = release_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Datasetsv1Annotation):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Datasetsv1Annotation):
            return True

        return self.to_dict() != other.to_dict()
