# coding: utf-8

"""
    NCBI Datasets API

    NCBI service to query and download biological sequence data across all domains of life from NCBI databases.  # noqa: E501

    The version of the OpenAPI document: v1alpha
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ncbi.datasets.openapi.configuration import Configuration


class V1GeneCounts(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'protein_coding': 'int',
        'total': 'int'
    }

    attribute_map = {
        'protein_coding': 'protein_coding',
        'total': 'total'
    }

    def __init__(self, protein_coding=None, total=None, local_vars_configuration=None):  # noqa: E501
        """V1GeneCounts - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._protein_coding = None
        self._total = None
        self.discriminator = None

        if protein_coding is not None:
            self.protein_coding = protein_coding
        if total is not None:
            self.total = total

    @property
    def protein_coding(self):
        """Gets the protein_coding of this V1GeneCounts.  # noqa: E501


        :return: The protein_coding of this V1GeneCounts.  # noqa: E501
        :rtype: int
        """
        return self._protein_coding

    @protein_coding.setter
    def protein_coding(self, protein_coding):
        """Sets the protein_coding of this V1GeneCounts.


        :param protein_coding: The protein_coding of this V1GeneCounts.  # noqa: E501
        :type: int
        """

        self._protein_coding = protein_coding

    @property
    def total(self):
        """Gets the total of this V1GeneCounts.  # noqa: E501


        :return: The total of this V1GeneCounts.  # noqa: E501
        :rtype: int
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this V1GeneCounts.


        :param total: The total of this V1GeneCounts.  # noqa: E501
        :type: int
        """

        self._total = total

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1GeneCounts):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, V1GeneCounts):
            return True

        return self.to_dict() != other.to_dict()
