# coding: utf-8

"""
    NCBI Datasets API

    NCBI service to query and download biological sequence data across all domains of life from NCBI databases.  # noqa: E501

    The version of the OpenAPI document: v1alpha
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ncbi.datasets.openapi.configuration import Configuration


class V1Message(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'error': 'V1Error',
        'warning': 'V1Warning'
    }

    attribute_map = {
        'error': 'error',
        'warning': 'warning'
    }

    def __init__(self, error=None, warning=None, local_vars_configuration=None):  # noqa: E501
        """V1Message - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._error = None
        self._warning = None
        self.discriminator = None

        if error is not None:
            self.error = error
        if warning is not None:
            self.warning = warning

    @property
    def error(self):
        """Gets the error of this V1Message.  # noqa: E501


        :return: The error of this V1Message.  # noqa: E501
        :rtype: V1Error
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this V1Message.


        :param error: The error of this V1Message.  # noqa: E501
        :type: V1Error
        """

        self._error = error

    @property
    def warning(self):
        """Gets the warning of this V1Message.  # noqa: E501


        :return: The warning of this V1Message.  # noqa: E501
        :rtype: V1Warning
        """
        return self._warning

    @warning.setter
    def warning(self, warning):
        """Sets the warning of this V1Message.


        :param warning: The warning of this V1Message.  # noqa: E501
        :type: V1Warning
        """

        self._warning = warning

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1Message):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, V1Message):
            return True

        return self.to_dict() != other.to_dict()
