# coding: utf-8

"""
    NCBI Datasets API

    NCBI service to query and download biological sequence data across all domains of life from NCBI databases.  # noqa: E501

    The version of the OpenAPI document: v1alpha
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ncbi.datasets.openapi.configuration import Configuration


class V1VersionReply(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'major_ver': 'int',
        'minor_ver': 'int',
        'patch_ver': 'int',
        'version': 'str'
    }

    attribute_map = {
        'major_ver': 'major_ver',
        'minor_ver': 'minor_ver',
        'patch_ver': 'patch_ver',
        'version': 'version'
    }

    def __init__(self, major_ver=None, minor_ver=None, patch_ver=None, version=None, local_vars_configuration=None):  # noqa: E501
        """V1VersionReply - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._major_ver = None
        self._minor_ver = None
        self._patch_ver = None
        self._version = None
        self.discriminator = None

        if major_ver is not None:
            self.major_ver = major_ver
        if minor_ver is not None:
            self.minor_ver = minor_ver
        if patch_ver is not None:
            self.patch_ver = patch_ver
        if version is not None:
            self.version = version

    @property
    def major_ver(self):
        """Gets the major_ver of this V1VersionReply.  # noqa: E501


        :return: The major_ver of this V1VersionReply.  # noqa: E501
        :rtype: int
        """
        return self._major_ver

    @major_ver.setter
    def major_ver(self, major_ver):
        """Sets the major_ver of this V1VersionReply.


        :param major_ver: The major_ver of this V1VersionReply.  # noqa: E501
        :type: int
        """

        self._major_ver = major_ver

    @property
    def minor_ver(self):
        """Gets the minor_ver of this V1VersionReply.  # noqa: E501


        :return: The minor_ver of this V1VersionReply.  # noqa: E501
        :rtype: int
        """
        return self._minor_ver

    @minor_ver.setter
    def minor_ver(self, minor_ver):
        """Sets the minor_ver of this V1VersionReply.


        :param minor_ver: The minor_ver of this V1VersionReply.  # noqa: E501
        :type: int
        """

        self._minor_ver = minor_ver

    @property
    def patch_ver(self):
        """Gets the patch_ver of this V1VersionReply.  # noqa: E501


        :return: The patch_ver of this V1VersionReply.  # noqa: E501
        :rtype: int
        """
        return self._patch_ver

    @patch_ver.setter
    def patch_ver(self, patch_ver):
        """Sets the patch_ver of this V1VersionReply.


        :param patch_ver: The patch_ver of this V1VersionReply.  # noqa: E501
        :type: int
        """

        self._patch_ver = patch_ver

    @property
    def version(self):
        """Gets the version of this V1VersionReply.  # noqa: E501


        :return: The version of this V1VersionReply.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this V1VersionReply.


        :param version: The version of this V1VersionReply.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1VersionReply):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, V1VersionReply):
            return True

        return self.to_dict() != other.to_dict()
